# wish < sequencer.tcl | ./demo TX81Z -or -ip

wm title . "STK TX81Z Interface"
wm iconname . "tx81z"
. config -bg black

set algorithm 5

set gain0    16.0
set attack0   1.0
set decay0   20.0
set sustain0  0.0
set release0  1.0
set ratio0    2.0
set detune0   0

set gain1    16.0
set attack1   1.0
set decay1   20.0
set sustain1  0.0
set release1  1.0
set ratio1    4.0
set detune1   0

set gain2    16.0
set attack2   1.0
set decay2   20.0
set sustain2  0.0
set release2  1.0
set ratio2    4.0
set detune2   0

set gain3    16.0
set attack3   1.0
set decay3   20.0
set sustain3  0.0
set release3  1.0
set ratio3    8.0
set detune3   0

set reverbLevel   0
set reverbTail    2
set masterVolume 30
set echoLength    6

puts "ControlChange  0 1 4999 5"
puts ""
puts "ControlChange  0 1 4000 16"
puts "ControlChange  0 1 4001 1"
puts "ControlChange  0 1 4002 20"
puts "ControlChange  0 1 4003 0"
puts "ControlChange  0 1 4004 1"
puts "ControlChange  0 1 4005 1"
puts "ControlChange  0 1 4006 1"
puts ""
puts "ControlChange  0 1 4010 16"
puts "ControlChange  0 1 4011 1"
puts "ControlChange  0 1 4012 20"
puts "ControlChange  0 1 4013 0"
puts "ControlChange  0 1 4014 1"
puts "ControlChange  0 1 4015 1"
puts "ControlChange  0 1 4016 1"
puts ""
puts "ControlChange  0 1 4020 16"
puts "ControlChange  0 1 4021 1"
puts "ControlChange  0 1 4022 20"
puts "ControlChange  0 1 4023 0"
puts "ControlChange  0 1 4024 1"
puts "ControlChange  0 1 4025 1"
puts "ControlChange  0 1 4026 1"
puts ""
puts "ControlChange  0 1 4030 16"
puts "ControlChange  0 1 4031 1"
puts "ControlChange  0 1 4032 20"
puts "ControlChange  0 1 4033 0"
puts "ControlChange  0 1 4034 1"
puts "ControlChange  0 1 4035 1"
puts "ControlChange  0 1 4036 1"

proc changeGain0 {value} {
    puts [format "ControlChange      0.0  1 4000 %3.2f" $value]
    flush stdout
}
proc changeAttack0 {value} {
    puts [format "ControlChange      0.0  1 4001 %3.2f" $value]
    flush stdout
}

proc changeDecay0 {value} {
    puts [format "ControlChange      0.0  1 4002 %3.2f" $value]
    flush stdout
}

proc changeSustain0 {value} {
    puts [format "ControlChange      0.0  1 4003 %3.2f" $value]
    flush stdout
}

proc changeRelease0 {value} {
    puts [format "ControlChange      0.0  1 4004 %3.2f" $value]
    flush stdout
}

proc changeRatio0 {value} {
    puts [format "ControlChange      0.0  1 4005 %3.2f" $value]
    flush stdout
}

proc changeDetune0 {value} {
    puts [format "ControlChange      0.0  1 4006 %3.2f" $value]
    flush stdout
}

proc changeGain1 {value} {
    puts [format "ControlChange      0.0  1 4010 %3.2f" $value]
    flush stdout
}


proc changeAttack1 {value} {
    puts [format "ControlChange      0.0  1 4011 %3.2f" $value]
    flush stdout
}


proc changeDecay1 {value} {
    puts [format "ControlChange      0.0  1 4012 %3.2f" $value]
    flush stdout
}


proc changeSustain1 {value} {
    puts [format "ControlChange      0.0  1 4013 %3.2f" $value]
    flush stdout
}


proc changeRelease1 {value} {
    puts [format "ControlChange      0.0  1 4014 %3.2f" $value]
    flush stdout
}

proc changeRatio1 {value} {
    puts [format "ControlChange      0.0  1 4015 %3.2f" $value]
    flush stdout
}

proc changeDetune1 {value} {
    puts [format "ControlChange      0.0  1 4016 %3.2f" $value]
    flush stdout
}

proc changeGain2 {value} {
    puts [format "ControlChange      0.0  1 4020 %3.2f" $value]
    flush stdout
}

proc changeAttack2 {value} {
    puts [format "ControlChange      0.0  1 4021 %3.2f" $value]
    flush stdout
}

proc changeDecay2 {value} {
    puts [format "ControlChange      0.0  1 4022 %3.2f" $value]
    flush stdout
}

proc changeSustain2 {value} {
    puts [format "ControlChange      0.0  1 4023 %3.2f" $value]
    flush stdout
}

proc changeRelease2 {value} {
    puts [format "ControlChange      0.0  1 4024 %3.2f" $value]
    flush stdout
}

proc changeRatio2 {value} {
    puts [format "ControlChange      0.0  1 4025 %3.2f" $value]
    flush stdout
}

proc changeDetune2 {value} {
    puts [format "ControlChange      0.0  1 4026 %3.2f" $value]
    flush stdout
}

proc changeGain3 {value} {
    puts [format "ControlChange      0.0  1 4030 %3.2f" $value]
    flush stdout
}

proc changeAttack3 {value} {
    puts [format "ControlChange      0.0  1 4031 %3.2f" $value]
    flush stdout
}

proc changeDecay3 {value} {
    puts [format "ControlChange      0.0  1 4032 %3.2f" $value]
    flush stdout
}

proc changeSustain3 {value} {
    puts [format "ControlChange      0.0  1 4033 %3.2f" $value]
    flush stdout
}

proc changeRelease3 {value} {
    puts [format "ControlChange      0.0  1 4034 %3.2f" $value]
    flush stdout
}

proc changeRatio3 {value} {
    puts [format "ControlChange      0.0  1 4035 %3.2f" $value]
    flush stdout
}

proc changeDetune3 {value} {
    puts [format "ControlChange      0.0  1 4036 %3.2f" $value]
    flush stdout
}
proc changeReverbLevel {value} {
    puts [format "ControlChange      0.0  1 4040 %3.2f" $value]
    flush stdout
}
proc changeReverbTail {value} {
    puts [format "ControlChange      0.0  1 4041 %3.2f" $value]
    flush stdout
}
proc changeMasterVolume {value} {
    puts [format "ControlChange      0.0  1 4042 %3.2f" $value]
    flush stdout
}
proc changeEchoLength {value} {
    puts [format "ControlChange      0.0  1 4043 %3.2f" $value]
    flush stdout
}


frame .f -width 160 -height 90 -borderwidth 5 -relief raised
pack .f

label .f.masterVolumeLabel -text "Master Volume" -font 16
grid  .f.masterVolumeLabel -row 0 -column 0
label .f.echoLengthLabel -text "Echo Length" -font 16
grid  .f.echoLengthLabel -row 0 -column 1
label .f.reverbLevelLabel -text "Reverb Level" -font 16
grid  .f.reverbLevelLabel -row 0 -column 2
label .f.reverbTailLabel -text "Reverb Tail" -font 16
grid  .f.reverbTailLabel -row 0 -column 3
scale .f.masterVolume -from 0 -to 100 -length 200 -orient horizontal -bg lightblue -variable masterVolume -command {changeMasterVolume } 
grid  .f.masterVolume -row 1 -column 0 
scale .f.echoLength -from 16 -to 128 -length 200 -orient horizontal -bg lightblue -variable echoLength -command {changeEchoLength } 
grid  .f.echoLength -row 1 -column 1 
scale .f.reverbLevel  -from 0 -to 100 -length 200 -orient horizontal -bg lightblue -variable reverbLevel -command {changeReverbLevel } 
grid  .f.reverbLevel  -row 1 -column 2 
scale .f.reverbTail   -from 1 -to 16 -length 200 -orient horizontal -bg lightblue -variable reverbTail -command {changeReverbTail } 
grid  .f.reverbTail   -row 1 -column 3 

frame  .f0 -width 160 -height 80 -borderwidth 5 -relief raised
pack   .f0


label  .f0.l1 -text "   012\[3\]   "
grid   .f0.l1 -row 0 -column 0
radiobutton .f0.r1 -text "1" -variable algorithm -value 1 -command {puts "ControlChange  0 1 4999 1"}
grid   .f0.r1 -row 1 -column 0

label  .f0.l2 -text "   01(2+\[3\])   "
grid   .f0.l2 -row 0 -column 1
radiobutton .f0.r2 -text "2" -variable algorithm -value 2 -command {puts "ControlChange  0 1 4999 2"}
grid   .f0.r2 -row 1 -column 1

label  .f0.l3 -text "   0(12+\[3\])   "
grid   .f0.l3 -row 0 -column 2
radiobutton .f0.r3 -text "3" -variable algorithm -value 3 -command {puts "ControlChange  0 1 4999 3"}
grid   .f0.r3 -row 1 -column 2

label  .f0.l4 -text "   0(1+2\[3\])   "
grid   .f0.l4 -row 0 -column 3
radiobutton .f0.r4 -text "4" -variable algorithm -value 4 -command {puts "ControlChange  0 1 4999 4"}
grid   .f0.r4 -row 1 -column 3

label  .f0.l5 -text "   01+2\[3\]   "
grid   .f0.l5 -row 0 -column 4
radiobutton .f0.r5 -text "5" -variable algorithm -value 5 -command {puts "ControlChange  0 1 4999 5"}
grid   .f0.r5 -row 1 -column 4

label  .f0.l6 -text "   0\[3\]+1\[3\]+2\[3\]   "
grid   .f0.l6 -row 0 -column 5
radiobutton .f0.r6 -text "6" -variable algorithm -value 6 -command {puts "ControlChange  0 1 4999 6"}
grid   .f0.r6 -row 1 -column 5

label  .f0.l7 -text "   0+1+2\[3\]   "
grid   .f0.l7 -row 0 -column 6
radiobutton .f0.r7 -text "7" -variable algorithm -value 7 -command {puts "ControlChange  0 1 4999 7"}
grid   .f0.r7 -row 1 -column 6

label  .f0.l8 -text "   0+1+2+\[3\]   "
grid   .f0.l8 -row 0 -column 7
radiobutton .f0.r8 -text "8" -variable algorithm -value 8 -command {puts "ControlChange  0 1 4999 8"}
grid   .f0.r8 -row 1 -column 7


frame .f9 -width 160 -height 100 -borderwidth 5 -relief raised
pack .f9

label .f9.gain -text "gain" -font 32
grid  .f9.gain -row 1 -column 0
label .f9.attack -text "attack" -font 32
grid  .f9.attack -row 2 -column 0
label .f9.decay -text "decay" -font 32
grid  .f9.decay -row 3 -column 0
label .f9.sustain -text "sustain" -font 32
grid  .f9.sustain -row 4 -column 0
label .f9.release -text "release" -font 32
grid  .f9.release -row 5 -column 0
label .f9.ratio -text "ratio" -font 32
grid  .f9.ratio -row 6 -column 0
label .f9.detune -text "detune" -font 32
grid  .f9.detune -row 7 -column 0
label .f9.op1 -text "Operator 0" -font 32
grid  .f9.op1 -row 0 -column 1
label .f9.op2 -text "Operator 1" -font 32
grid  .f9.op2 -row 0 -column 2
label .f9.op3 -text "Operator 2" -font 32
grid  .f9.op3 -row 0 -column 3
label .f9.op4 -text "Operator 3" -font 32
grid  .f9.op4 -row 0 -column 4

scale .f9.gain0 -from 0 -to 128 -length 200 -orient horizontal -bg lightblue -variable gain0 -command {changeGain0 } 
grid  .f9.gain0 -row 1 -column 1
scale .f9.attack0 -from 1 -to 128 -length 200 -orient horizontal -variable attack0 -command {changeAttack0 }
grid  .f9.attack0 -row 2 -column 1
scale .f9.decay0 -from 1 -to 128 -length 200 -orient horizontal -variable decay0 -command {changeDecay0 }
grid  .f9.decay0 -row 3 -column 1
scale .f9.sustain0 -from 0 -to 128 -length 200 -orient horizontal -variable sustain0 -command {changeSustain0 }
grid  .f9.sustain0 -row 4 -column 1
scale .f9.release0 -from 1 -to 128 -length 200 -orient horizontal -variable release0 -command {changeRelease0 }
grid  .f9.release0 -row 5 -column 1
scale .f9.ratio0 -from 0 -to 32 -length 200 -orient horizontal -variable ratio0 -command {changeRatio0 }
grid  .f9.ratio0 -row 6 -column 1
scale .f9.detune0 -from -7 -to 7 -length 200 -orient horizontal -variable detune0 -command {changeDetune0 }
grid  .f9.detune0 -row 7 -column 1

scale .f9.gain1 -from 0 -to 128 -length 200 -orient horizontal -bg lightblue -variable gain1 -command {changeGain1 } 
grid  .f9.gain1 -row 1 -column 2
scale .f9.attack1 -from 1 -to 128 -length 200 -orient horizontal -variable attack1 -command {changeAttack1 }
grid  .f9.attack1 -row 2 -column 2
scale .f9.decay1 -from 1 -to 128 -length 200 -orient horizontal -variable decay1 -command {changeDecay1 }
grid  .f9.decay1 -row 3 -column 2
scale .f9.sustain1 -from 0 -to 128 -length 200 -orient horizontal -variable sustain1 -command {changeSustain1 }
grid  .f9.sustain1 -row 4 -column 2
scale .f9.release1 -from 1 -to 128 -length 200 -orient horizontal -variable release1 -command {changeRelease1 }
grid  .f9.release1 -row 5 -column 2
scale .f9.ratio1 -from 0 -to 32 -length 200 -orient horizontal -variable ratio1 -command {changeRatio1 }
grid  .f9.ratio1 -row 6 -column 2
scale .f9.detune1 -from -7 -to 7 -length 200 -orient horizontal -variable detune1 -command {changeDetune1 }
grid  .f9.detune1 -row 7 -column 2

scale .f9.gain2 -from 0 -to 128 -length 200 -orient horizontal -bg lightblue -variable gain2 -command {changeGain2 } 
grid  .f9.gain2 -row 1 -column 3 
scale .f9.attack2 -from 1 -to 128 -length 200 -orient horizontal -variable attack2 -command {changeAttack2 }
grid  .f9.attack2 -row 2 -column 3
scale .f9.decay2 -from 1 -to 128 -length 200 -orient horizontal -variable decay2 -command {changeDecay2 }
grid  .f9.decay2 -row 3 -column 3
scale .f9.sustain2 -from 0 -to 128 -length 200 -orient horizontal -variable sustain2 -command {changeSustain2 }
grid  .f9.sustain2 -row 4 -column 3
scale .f9.release2 -from 1 -to 128 -length 200 -orient horizontal -variable release2 -command {changeRelease2 }
grid  .f9.release2 -row 5 -column 3
scale .f9.ratio2 -from 0 -to 32 -length 200 -orient horizontal -variable ratio2 -command {changeRatio2 }
grid  .f9.ratio2 -row 6 -column 3
scale .f9.detune2 -from -7 -to 7 -length 200 -orient horizontal -variable detune2 -command {changeDetune2 }
grid  .f9.detune2 -row 7 -column 3

scale .f9.gain3 -from 0 -to 128 -length 200 -orient horizontal -bg lightblue -variable gain3 -command {changeGain3 } 
grid  .f9.gain3 -row 1 -column 4
scale .f9.attack3 -from 1 -to 128 -length 200 -orient horizontal -variable attack3 -command {changeAttack3 }
grid  .f9.attack3 -row 2 -column 4
scale .f9.decay3 -from 1 -to 128 -length 200 -orient horizontal -variable decay3 -command {changeDecay3 }
grid  .f9.decay3 -row 3 -column 4
scale .f9.sustain3 -from 0 -to 128 -length 200 -orient horizontal -variable sustain3 -command {changeSustain3 }
grid  .f9.sustain3 -row 4 -column 4
scale .f9.release3 -from 1 -to 128 -length 200 -orient horizontal -variable release3 -command {changeRelease3 }
grid  .f9.release3 -row 5 -column 4
scale .f9.ratio3 -from 0 -to 32 -length 200 -orient horizontal -variable ratio3 -command {changeRatio3 }
grid  .f9.ratio3 -row 6 -column 4
scale .f9.detune3 -from -7 -to 7 -length 200 -orient horizontal -variable detune3 -command {changeDetune3 }
grid  .f9.detune3 -row 7 -column 4
    

#frame .f1 -width 160 -height 10 -borderwidth 5 -relief raised
#pack .f1

#button .f1.b1 -text "play" -relief raised -background lightgreen -command {play}
#grid .f1.b1 -row 0 -column 0
#button .f1.b2 -text "stop" -relief raised -background lightblue
#grid .f1.b2 -row 0 -column 1
#button .f1.b3 -text "record" -relief raised -background red
#grid .f1.b3 -row 0 -column 2
#button .f1.b8 -text "store" -relief raised -background orange
#grid .f1.b8 -row 0 -column 3

